// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:action/TrackPath.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "kompass_interfaces/action/track_path.hpp"


#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_PATH__TRAITS_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_PATH__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/action/detail/track_path__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'follow_path'
#include "kompass_interfaces/msg/detail/follow_path_request__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const TrackPath_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: number_of_cmds
  {
    out << "number_of_cmds: ";
    rosidl_generator_traits::value_to_yaml(msg.number_of_cmds, out);
    out << ", ";
  }

  // member: time_step
  {
    out << "time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.time_step, out);
    out << ", ";
  }

  // member: follow_path
  {
    out << "follow_path: ";
    to_flow_style_yaml(msg.follow_path, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrackPath_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: number_of_cmds
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_of_cmds: ";
    rosidl_generator_traits::value_to_yaml(msg.number_of_cmds, out);
    out << "\n";
  }

  // member: time_step
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.time_step, out);
    out << "\n";
  }

  // member: follow_path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "follow_path:\n";
    to_block_style_yaml(msg.follow_path, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrackPath_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_Goal>()
{
  return "kompass_interfaces::action::TrackPath_Goal";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_Goal>()
{
  return "kompass_interfaces/action/TrackPath_Goal";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_Goal>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::msg::FollowPathRequest>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_Goal>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::msg::FollowPathRequest>::value> {};

template<>
struct is_message<kompass_interfaces::action::TrackPath_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'tracking_error'
#include "kompass_interfaces/msg/detail/path_tracking_error__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const TrackPath_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: reached_end
  {
    out << "reached_end: ";
    rosidl_generator_traits::value_to_yaml(msg.reached_end, out);
    out << ", ";
  }

  // member: tracking_error
  {
    out << "tracking_error: ";
    to_flow_style_yaml(msg.tracking_error, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrackPath_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: reached_end
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reached_end: ";
    rosidl_generator_traits::value_to_yaml(msg.reached_end, out);
    out << "\n";
  }

  // member: tracking_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tracking_error:\n";
    to_block_style_yaml(msg.tracking_error, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrackPath_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_Result>()
{
  return "kompass_interfaces::action::TrackPath_Result";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_Result>()
{
  return "kompass_interfaces/action/TrackPath_Result";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_Result>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::msg::PathTrackingError>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_Result>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::msg::PathTrackingError>::value> {};

template<>
struct is_message<kompass_interfaces::action::TrackPath_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'cmd_list'
#include "kompass_interfaces/msg/detail/twist_array__traits.hpp"
// Member 'global_path'
#include "nav_msgs/msg/detail/path__traits.hpp"
// Member 'tracking_errors'
#include "kompass_interfaces/msg/detail/path_tracking_error_array__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const TrackPath_Feedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: cmd_list
  {
    out << "cmd_list: ";
    to_flow_style_yaml(msg.cmd_list, out);
    out << ", ";
  }

  // member: global_path
  {
    out << "global_path: ";
    to_flow_style_yaml(msg.global_path, out);
    out << ", ";
  }

  // member: tracking_errors
  {
    out << "tracking_errors: ";
    to_flow_style_yaml(msg.tracking_errors, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrackPath_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: cmd_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cmd_list:\n";
    to_block_style_yaml(msg.cmd_list, out, indentation + 2);
  }

  // member: global_path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "global_path:\n";
    to_block_style_yaml(msg.global_path, out, indentation + 2);
  }

  // member: tracking_errors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tracking_errors:\n";
    to_block_style_yaml(msg.tracking_errors, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrackPath_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_Feedback>()
{
  return "kompass_interfaces::action::TrackPath_Feedback";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_Feedback>()
{
  return "kompass_interfaces/action/TrackPath_Feedback";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_Feedback>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::msg::PathTrackingErrorArray>::value && has_fixed_size<kompass_interfaces::msg::TwistArray>::value && has_fixed_size<nav_msgs::msg::Path>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_Feedback>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::msg::PathTrackingErrorArray>::value && has_bounded_size<kompass_interfaces::msg::TwistArray>::value && has_bounded_size<nav_msgs::msg::Path>::value> {};

template<>
struct is_message<kompass_interfaces::action::TrackPath_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "kompass_interfaces/action/detail/track_path__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const TrackPath_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrackPath_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrackPath_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_SendGoal_Request>()
{
  return "kompass_interfaces::action::TrackPath_SendGoal_Request";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_SendGoal_Request>()
{
  return "kompass_interfaces/action/TrackPath_SendGoal_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::action::TrackPath_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::TrackPath_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<kompass_interfaces::action::TrackPath_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const TrackPath_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrackPath_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrackPath_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_SendGoal_Response>()
{
  return "kompass_interfaces::action::TrackPath_SendGoal_Response";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_SendGoal_Response>()
{
  return "kompass_interfaces/action/TrackPath_SendGoal_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<kompass_interfaces::action::TrackPath_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const TrackPath_SendGoal_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrackPath_SendGoal_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrackPath_SendGoal_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_SendGoal_Event>()
{
  return "kompass_interfaces::action::TrackPath_SendGoal_Event";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_SendGoal_Event>()
{
  return "kompass_interfaces/action/TrackPath_SendGoal_Event";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_SendGoal_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_SendGoal_Event>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::TrackPath_SendGoal_Request>::value && has_bounded_size<kompass_interfaces::action::TrackPath_SendGoal_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<kompass_interfaces::action::TrackPath_SendGoal_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_SendGoal>()
{
  return "kompass_interfaces::action::TrackPath_SendGoal";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_SendGoal>()
{
  return "kompass_interfaces/action/TrackPath_SendGoal";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::action::TrackPath_SendGoal_Request>::value &&
    has_fixed_size<kompass_interfaces::action::TrackPath_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::action::TrackPath_SendGoal_Request>::value &&
    has_bounded_size<kompass_interfaces::action::TrackPath_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::action::TrackPath_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::action::TrackPath_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::action::TrackPath_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const TrackPath_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrackPath_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrackPath_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_GetResult_Request>()
{
  return "kompass_interfaces::action::TrackPath_GetResult_Request";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_GetResult_Request>()
{
  return "kompass_interfaces/action/TrackPath_GetResult_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<kompass_interfaces::action::TrackPath_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/track_path__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const TrackPath_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrackPath_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrackPath_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_GetResult_Response>()
{
  return "kompass_interfaces::action::TrackPath_GetResult_Response";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_GetResult_Response>()
{
  return "kompass_interfaces/action/TrackPath_GetResult_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::action::TrackPath_Result>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::TrackPath_Result>::value> {};

template<>
struct is_message<kompass_interfaces::action::TrackPath_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
// already included above
// #include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const TrackPath_GetResult_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrackPath_GetResult_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrackPath_GetResult_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_GetResult_Event>()
{
  return "kompass_interfaces::action::TrackPath_GetResult_Event";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_GetResult_Event>()
{
  return "kompass_interfaces/action/TrackPath_GetResult_Event";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_GetResult_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_GetResult_Event>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::TrackPath_GetResult_Request>::value && has_bounded_size<kompass_interfaces::action::TrackPath_GetResult_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<kompass_interfaces::action::TrackPath_GetResult_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_GetResult>()
{
  return "kompass_interfaces::action::TrackPath_GetResult";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_GetResult>()
{
  return "kompass_interfaces/action/TrackPath_GetResult";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::action::TrackPath_GetResult_Request>::value &&
    has_fixed_size<kompass_interfaces::action::TrackPath_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::action::TrackPath_GetResult_Request>::value &&
    has_bounded_size<kompass_interfaces::action::TrackPath_GetResult_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::action::TrackPath_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::action::TrackPath_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::action::TrackPath_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/track_path__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const TrackPath_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrackPath_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrackPath_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath_FeedbackMessage>()
{
  return "kompass_interfaces::action::TrackPath_FeedbackMessage";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath_FeedbackMessage>()
{
  return "kompass_interfaces/action/TrackPath_FeedbackMessage";
}

template<>
struct has_fixed_size<kompass_interfaces::action::TrackPath_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::action::TrackPath_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::TrackPath_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::TrackPath_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<kompass_interfaces::action::TrackPath_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::TrackPath>()
{
  return "kompass_interfaces::action::TrackPath";
}

template<>
inline const char * name<kompass_interfaces::action::TrackPath>()
{
  return "kompass_interfaces/action/TrackPath";
}

template<>
struct is_action<kompass_interfaces::action::TrackPath>
  : std::true_type
{
};

template<>
struct is_action_goal<kompass_interfaces::action::TrackPath_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<kompass_interfaces::action::TrackPath_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<kompass_interfaces::action::TrackPath_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_PATH__TRAITS_HPP_
