// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:srv/GetPredictedOccupancies.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "kompass_interfaces/srv/get_predicted_occupancies.hpp"


#ifndef KOMPASS_INTERFACES__SRV__DETAIL__GET_PREDICTED_OCCUPANCIES__TRAITS_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__GET_PREDICTED_OCCUPANCIES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/srv/detail/get_predicted_occupancies__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetPredictedOccupancies_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: start_time
  {
    out << "start_time: ";
    rosidl_generator_traits::value_to_yaml(msg.start_time, out);
    out << ", ";
  }

  // member: horizon
  {
    out << "horizon: ";
    rosidl_generator_traits::value_to_yaml(msg.horizon, out);
    out << ", ";
  }

  // member: time_step
  {
    out << "time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.time_step, out);
    out << ", ";
  }

  // member: prediction_model_type
  {
    out << "prediction_model_type: ";
    rosidl_generator_traits::value_to_yaml(msg.prediction_model_type, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetPredictedOccupancies_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: start_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start_time: ";
    rosidl_generator_traits::value_to_yaml(msg.start_time, out);
    out << "\n";
  }

  // member: horizon
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "horizon: ";
    rosidl_generator_traits::value_to_yaml(msg.horizon, out);
    out << "\n";
  }

  // member: time_step
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.time_step, out);
    out << "\n";
  }

  // member: prediction_model_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "prediction_model_type: ";
    rosidl_generator_traits::value_to_yaml(msg.prediction_model_type, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetPredictedOccupancies_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::GetPredictedOccupancies_Request>()
{
  return "kompass_interfaces::srv::GetPredictedOccupancies_Request";
}

template<>
inline const char * name<kompass_interfaces::srv::GetPredictedOccupancies_Request>()
{
  return "kompass_interfaces/srv/GetPredictedOccupancies_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::GetPredictedOccupancies_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::GetPredictedOccupancies_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::srv::GetPredictedOccupancies_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetPredictedOccupancies_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: prediction_completed
  {
    out << "prediction_completed: ";
    rosidl_generator_traits::value_to_yaml(msg.prediction_completed, out);
    out << ", ";
  }

  // member: predicted_occupancies_topic_name
  {
    out << "predicted_occupancies_topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.predicted_occupancies_topic_name, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetPredictedOccupancies_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: prediction_completed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "prediction_completed: ";
    rosidl_generator_traits::value_to_yaml(msg.prediction_completed, out);
    out << "\n";
  }

  // member: predicted_occupancies_topic_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "predicted_occupancies_topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.predicted_occupancies_topic_name, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetPredictedOccupancies_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::GetPredictedOccupancies_Response>()
{
  return "kompass_interfaces::srv::GetPredictedOccupancies_Response";
}

template<>
inline const char * name<kompass_interfaces::srv::GetPredictedOccupancies_Response>()
{
  return "kompass_interfaces/srv/GetPredictedOccupancies_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::GetPredictedOccupancies_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::GetPredictedOccupancies_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::srv::GetPredictedOccupancies_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetPredictedOccupancies_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetPredictedOccupancies_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetPredictedOccupancies_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::GetPredictedOccupancies_Event>()
{
  return "kompass_interfaces::srv::GetPredictedOccupancies_Event";
}

template<>
inline const char * name<kompass_interfaces::srv::GetPredictedOccupancies_Event>()
{
  return "kompass_interfaces/srv/GetPredictedOccupancies_Event";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::GetPredictedOccupancies_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::GetPredictedOccupancies_Event>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::srv::GetPredictedOccupancies_Request>::value && has_bounded_size<kompass_interfaces::srv::GetPredictedOccupancies_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<kompass_interfaces::srv::GetPredictedOccupancies_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::GetPredictedOccupancies>()
{
  return "kompass_interfaces::srv::GetPredictedOccupancies";
}

template<>
inline const char * name<kompass_interfaces::srv::GetPredictedOccupancies>()
{
  return "kompass_interfaces/srv/GetPredictedOccupancies";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::GetPredictedOccupancies>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::srv::GetPredictedOccupancies_Request>::value &&
    has_fixed_size<kompass_interfaces::srv::GetPredictedOccupancies_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::srv::GetPredictedOccupancies>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::srv::GetPredictedOccupancies_Request>::value &&
    has_bounded_size<kompass_interfaces::srv::GetPredictedOccupancies_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::srv::GetPredictedOccupancies>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::srv::GetPredictedOccupancies_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::srv::GetPredictedOccupancies_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__GET_PREDICTED_OCCUPANCIES__TRAITS_HPP_
