// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:srv/StartPathRecording.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "kompass_interfaces/srv/start_path_recording.hpp"


#ifndef KOMPASS_INTERFACES__SRV__DETAIL__START_PATH_RECORDING__TRAITS_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__START_PATH_RECORDING__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/srv/detail/start_path_recording__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StartPathRecording_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: recording_time_step
  {
    out << "recording_time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_time_step, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StartPathRecording_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: recording_time_step
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "recording_time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_time_step, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StartPathRecording_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::StartPathRecording_Request>()
{
  return "kompass_interfaces::srv::StartPathRecording_Request";
}

template<>
inline const char * name<kompass_interfaces::srv::StartPathRecording_Request>()
{
  return "kompass_interfaces/srv/StartPathRecording_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::StartPathRecording_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::StartPathRecording_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<kompass_interfaces::srv::StartPathRecording_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StartPathRecording_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: started_recording
  {
    out << "started_recording: ";
    rosidl_generator_traits::value_to_yaml(msg.started_recording, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StartPathRecording_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: started_recording
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "started_recording: ";
    rosidl_generator_traits::value_to_yaml(msg.started_recording, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StartPathRecording_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::StartPathRecording_Response>()
{
  return "kompass_interfaces::srv::StartPathRecording_Response";
}

template<>
inline const char * name<kompass_interfaces::srv::StartPathRecording_Response>()
{
  return "kompass_interfaces/srv/StartPathRecording_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::StartPathRecording_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::StartPathRecording_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::srv::StartPathRecording_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StartPathRecording_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StartPathRecording_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StartPathRecording_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::StartPathRecording_Event>()
{
  return "kompass_interfaces::srv::StartPathRecording_Event";
}

template<>
inline const char * name<kompass_interfaces::srv::StartPathRecording_Event>()
{
  return "kompass_interfaces/srv/StartPathRecording_Event";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::StartPathRecording_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::StartPathRecording_Event>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::srv::StartPathRecording_Request>::value && has_bounded_size<kompass_interfaces::srv::StartPathRecording_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<kompass_interfaces::srv::StartPathRecording_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::StartPathRecording>()
{
  return "kompass_interfaces::srv::StartPathRecording";
}

template<>
inline const char * name<kompass_interfaces::srv::StartPathRecording>()
{
  return "kompass_interfaces/srv/StartPathRecording";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::StartPathRecording>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::srv::StartPathRecording_Request>::value &&
    has_fixed_size<kompass_interfaces::srv::StartPathRecording_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::srv::StartPathRecording>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::srv::StartPathRecording_Request>::value &&
    has_bounded_size<kompass_interfaces::srv::StartPathRecording_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::srv::StartPathRecording>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::srv::StartPathRecording_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::srv::StartPathRecording_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__START_PATH_RECORDING__TRAITS_HPP_
